/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.testdata.TestIrregularFieldFlow;

import static org.apache.commons.math3.util.FastMath.*;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import org.visnow.vn.gui.widgets.RunButton;
import static org.visnow.vn.lib.basic.testdata.TestIrregularFieldFlow.TestIrregularFieldFlowShared.*;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class GUI extends javax.swing.JPanel
{

    private Parameters parameters;

    /**
     * Creates new form SliceUI
     */
    public GUI()
    {
        initComponents();
    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    void updateGUI(final ParameterProxy p, boolean resetFully, boolean setRunButtonPending)
    {
        int numPoints = p.get(POINT_COUNT);

        if (nSlider.getMax() < numPoints) nSlider.setMax(numPoints);
        if (nSlider.getMin() > numPoints) nSlider.setMin(numPoints);
        nSlider.setVal(numPoints);

        int numTimeSteps = p.get(TIMESTEPS_NUMBER);
        if (framesSlider.getMax() < numTimeSteps) framesSlider.setMax(numTimeSteps);
        if (framesSlider.getMin() > numTimeSteps) framesSlider.setMin(numTimeSteps);
        framesSlider.setVal(numTimeSteps);
        
        runButton.updateAutoState(p.get(RUNNING_MESSAGE));
        runButton.updatePendingState(setRunButtonPending);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        nSlider = new org.visnow.vn.gui.widgets.EnhancedIntSlider();
        framesSlider = new org.visnow.vn.gui.widgets.EnhancedIntSlider();
        runButton = new org.visnow.vn.gui.widgets.RunButton();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));

        setMinimumSize(new java.awt.Dimension(180, 140));
        setPreferredSize(new java.awt.Dimension(200, 150));
        setLayout(new java.awt.GridBagLayout());

        nSlider.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "particles number", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10))); // NOI18N
        nSlider.setMin(1);
        nSlider.setMinimumSize(new java.awt.Dimension(180, 62));
        nSlider.setPreferredSize(new java.awt.Dimension(200, 62));
        nSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                nSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        add(nSlider, gridBagConstraints);

        framesSlider.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "time frames number", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10))); // NOI18N
        framesSlider.setMax(1000);
        framesSlider.setMin(1);
        framesSlider.setMinimumSize(new java.awt.Dimension(180, 62));
        framesSlider.setPreferredSize(new java.awt.Dimension(200, 62));
        framesSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                framesSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        add(framesSlider, gridBagConstraints);

        runButton.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                runButtonUserChangeAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_END;
        add(runButton, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void nSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_nSliderStateChanged
    {//GEN-HEADEREND:event_nSliderStateChanged
        if (!nSlider.isAdjusting()) {
            parameters.set(POINT_COUNT, max(1, nSlider.getVal()));
            runButton.setPendingIfNoAuto();
        }
    }//GEN-LAST:event_nSliderStateChanged

    private void framesSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_framesSliderStateChanged
        if (!framesSlider.isAdjusting()) {
            parameters.set(TIMESTEPS_NUMBER, max(1, framesSlider.getVal()));
            runButton.setPendingIfNoAuto();
        }
    }//GEN-LAST:event_framesSliderStateChanged

    private void runButtonUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {//GEN-FIRST:event_runButtonUserChangeAction
        parameters.set(RUNNING_MESSAGE, (RunButton.RunState) evt.getEventData());
    }//GEN-LAST:event_runButtonUserChangeAction


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.Box.Filler filler1;
    private org.visnow.vn.gui.widgets.EnhancedIntSlider framesSlider;
    private org.visnow.vn.gui.widgets.EnhancedIntSlider nSlider;
    private org.visnow.vn.gui.widgets.RunButton runButton;
    // End of variables declaration//GEN-END:variables

}
